// Beispiel fuer virtuelle Klassen bei Mehrfachvererbung
// bei virtuellen Klassen und Mehrfachvererbung wird der Konstruktur der
// gemeinsamen Basisklasse in der am weitesten entfernten Klasse aufgerufen,
// nicht jedoch in den anderen Klassen der Vererbungshierarchie
#include <iostream>
#include <string>

using namespace std;

#define DEBUG
#ifdef DEBUG
#define debug(a, b)	cout <<a<<b<<endl
#else
#define debug(a, b)	
#endif

// Basisklasse Flugzeug
class fzeug {
public:		string id;
	fzeug(string s="(fzeug)") { debug("fzeug konstrukt with ", s); id = s; }
};

// abgeleitete Klasse Passagierflugzeug - virtuelle Vererbung noetig!!
class passfzeug : public virtual fzeug {
public:
	passfzeug(string init="(passfzeug)") : fzeug(init) {
		debug("passfzeug konstrukt with ", init);
	}
};

// abgeleitete Klasse Militaerflieger - virtuelle Vererbung noetig!!
class milflieger : public virtual fzeug {
public:	

	void ausgabe() { cout<<"milflieger"<<endl; }
	milflieger(string init="(milflieger)") : fzeug(init) {
		debug("milflieger konstrukt with ", init);
	}
};

// Mehrfachvererbung: ein Truppenflieger ist ein Militaerflugzeug und
// auch ein Passagierflugzeug
class truppenflieger : public milflieger, public passfzeug {
#if 1
public:
	// AUfruf des Basisklasseninitialisierers geschieht hier!!
	truppenflieger(string init="(truppenflieger)") : fzeug(init) {
		debug("truppenflieger konstrukt with ", init);
	}
#endif
};

int main()
{
	truppenflieger jet;
	cout << jet.milflieger::id<<endl;
	cout << jet.passfzeug::id<<endl;

	return 0;
}
