#include <qapplication.h>
#include <qmenubar.h>
#include <qmessagebox.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qpopupmenu.h>
#include <qwidget.h>

enum MenuIDs{		// menu item's corresponding numbers
    COLOR_MENU_ID_BLACK,
    COLOR_MENU_ID_RED,
    COLOR_MENU_ID_BLUE,
    COLOR_MENU_ID_GREEN,
    COLOR_MENU_ID_YELLOW };

/**
  * A class that lets the user draw with the mouse. The
  * window knows how to redraw itself.
  */
class ScribbleWindow : public QWidget
{
  Q_OBJECT  // necessary because ScribbleWindow contains slots
  
public:
  ScribbleWindow();
  ~ScribbleWindow();

protected:
  virtual void mousePressEvent( QMouseEvent* );	// mouse button pressed
  virtual void mouseMoveEvent( QMouseEvent* );	// moved AND button pressed
  virtual void paintEvent( QPaintEvent* );	// widget must be repainted
  virtual void resizeEvent( QResizeEvent* );	// widget was resized

private slots:
  void slotAbout();			// tell me more about the program
  void slotAboutQt();			// tell me more about Qt
  void slotColorMenu( int );		// new color has been selected

private:
  QPoint _last;				// point where button was pressed
  QColor _currentcolor;			// current painting color

  QPixmap _buffer;			// buffer copy of the screen
  QMenuBar* _menubar;			// menu bar :-)
  QPopupMenu* _filemenu;		// menu item filemenu :-)
  QPopupMenu* _colormenu;		// ... (read and understand!)
  QPopupMenu* _helpmenu;		// ... (read and understand!)
};
